Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports GTA
Public Class SuperVillian
    Inherits script
    Private SON As Boolean = False
    Private enemy As Boolean = False
    Private anims As New AnimationSet("gestures@mp_male")
    Private animflags As AnimationFlags = AnimationFlags.Unknown12 Or AnimationFlags.Unknown11 Or AnimationFlags.Unknown09
    Public Sub New()
        'Me.interval = 100
        settings.load()
        BindKey(Settings.GetValueKey("Toggle Script", "SETTINGS", Keys.F6), New KeyPressDelegate(AddressOf ScriptOn))
        BindKey(Settings.GetValueKey("Spawn Enemy", "SETTINGS", Keys.Insert), New KeyPressDelegate(AddressOf TheEnemy))
        BindKey(Settings.GetValueKey("Add Blip To Villian", "SETTINGS", Keys.B), New KeyPressDelegate(AddressOf AddBlip))
    End Sub
    Private Function RandomNumber(ByVal min As Integer, ByVal max As Integer) As Integer
        Dim random As New Random()
        Return random.Next(min, max)
    End Function
    Private Sub TheEnemy()
        If SON Then
            Dim ped As ped = world.createped("M_Y_Prison", player.character.position.around(20.0F).toground)
            If exists(ped) Then
                ped.becomemissioncharacter()
                ped.CurrentRoom = Player.Character.CurrentRoom
                ped.SetPathfinding(True, True, True)
                ped.AlwaysDiesOnLowHealth = True
                ped.enemy = True
                ped.Accuracy = 100
                Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", Ped, 5.0F)
                Native.Function.Call("Set_Char_Climb_Anim_Rate", Ped, 5.0F)
                Ped.StartKillingSpree(alsoAttackPlayer:=True)
                ped.Weapons.MP5.Ammo = 99999
                ped.Weapons.Knife.Ammo = 99999
                ped.relationshipgroup = relationshipgroup.criminal
                ped.maxhealth = 15000
                ped.armor = 15000
                ped.health = 15000
                Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Super Villian Spawned", 4000, 1)
                Dim objct As gta.object = world.createobject("cj_barrier_7", ped.position)
                wait(20)
                objct.attachtoped(ped, 1204, New vector3(0.25F, 0.3F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
                objct.visible = False
                wait(10)
                objct = world.createobject("cj_barrier_7", ped.position)
                objct.visible = False
                wait(20)
                objct.attachtoped(ped, 1204, New vector3(0.0F, -0.3F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
                wait(10)
                objct = world.createobject("cj_barrier_7", ped.position)
                objct.visible = False
                wait(20)
                objct.attachtoped(ped, 1204, New vector3(0.05F, 0.0F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
            End If
            player.character.Weapons.BasicSniperRifle.Ammo = 8 'for some reason brings up better SniperRifle_M40A1 
        End If
    End Sub
    Private Sub Villian_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If SON Then
            Dim peds As ped() = World.GetAllPeds("M_Y_Prison")
            For Each ped As ped In peds
                If exists(ped) AndAlso Player.Character.Position.DistanceTo(ped.Position) >= 1.0F AndAlso Ped.isShooting = False AndAlso ped.isrequiredformission = True AndAlso ped.isalive = True Then
                    ped.visible = False
                    Ped.WantedByPolice = False
                    Ped.MakeProofTo(False, False, True, True, False) 'Bullets,Fire,Explosions,FallingDamage,MeleeAttacks - tired of looking it up :)
                    Dim WorldObjects As GTA.Object() = World.GetAllObjects("cj_barrier_7")
                    For Each obj As GTA.Object In WorldObjects
                        If Exists(obj) AndAlso obj.Position.DistanceTo(ped.Position) <= 4.0F Then
                            obj.visible = False
                        End If
                    Next
                Else
                    If exists(ped) AndAlso Ped.isShooting = True Then
                        ped.visible = True
                        Ped.WantedByPolice = True
                        Ped.MakeProofTo(True, True, True, True, False)
                        Dim WorldObjects As GTA.Object() = World.GetAllObjects("cj_barrier_7")
                        For Each obj As GTA.Object In WorldObjects
                            If Exists(obj) AndAlso obj.Position.DistanceTo(ped.Position) <= 4.0F Then
                                obj.visible = False
                            End If
                        Next
                    End If
                End If
                If exists(ped) AndAlso ped.isalive = True Then
                    If player.character.Weapons.MP5.Ammo < 1200 Then player.character.Weapons.MP5.Ammo += 1
                    If player.character.Weapons.Deserteagle.Ammo < 1500 Then player.character.Weapons.DesertEagle.Ammo += 1
                    If player.character.Weapons.BarettaShotgun.Ammo < 80 Then player.character.Weapons.BarettaShotgun.Ammo += 1
                    If player.character.Weapons.MolotovCocktails.Ammo < 25 Then player.character.Weapons.MolotovCocktails.Ammo += 1
                    If player.character.Weapons.AssaultRifle_M4.Ammo < 600 Then player.character.Weapons.AssaultRifle_M4.Ammo += 1
                    If player.character.Weapons.RocketLauncher.Ammo < 8 Then player.character.Weapons.RocketLauncher.Ammo += 1
                End If
            Next
            Dim pedz As ped() = World.GetAllPeds("M_Y_Prison")
            For Each ped As ped In pedz
                If exists(ped) AndAlso ped.isrequiredformission = True AndAlso ped.isdead = True Then
                    ped.visible = True
                    Dim WorldObjects As GTA.Object() = World.GetAllObjects("cj_barrier_7")
                    For Each obj As GTA.Object In WorldObjects
                        If Exists(obj) AndAlso obj.Position.DistanceTo(ped.Position) <= 2.0F Then
                            obj.delete()
                        End If
                    Next
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.criminal = True Then
                        Hydra(ped)
                        ped.nolongerneeded()
                        Hydra(ped)
                    End If
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.dealer = True Then
                        Hydra2(ped)
                        ped.nolongerneeded()
                        Hydra2(ped)
                    End If
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.dealer = False AndAlso ped.relationshipgroup = relationshipgroup.criminal = False Then
                        ped.nolongerneeded()
                    End If
                End If
            Next
            Dim pedsz As ped() = World.GetAllPeds("M_Y_Prison")
            For Each ped As ped In pedsz
                If exists(ped) AndAlso ped.isragdoll = True AndAlso ped.isalive = True AndAlso ped.isrequiredformission = True Then
                    ped.visible = True
                    Ped.MakeProofTo(True, False, True, False, True)
                    Dim WorldObjects As GTA.Object() = World.GetAllObjects("cj_barrier_7")
                    For Each obj As GTA.Object In WorldObjects
                        If Exists(obj) AndAlso obj.Position.DistanceTo(ped.Position) <= 4.0F Then
                            obj.visible = False
                        End If
                    Next
                End If
            Next
        End If
    End Sub
    Private Sub Hydra(ByVal ped As ped)
        Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "HE MULTIPLIED!", 4000, 1)
        ped = world.createped("M_Y_Prison", player.character.position.around(20.0F).toground)
        ped.becomemissioncharacter()
        ped.CurrentRoom = Player.Character.CurrentRoom
        ped.SetPathfinding(True, True, True)
        ped.AlwaysDiesOnLowHealth = True
        ped.enemy = True
        ped.Accuracy = 100
        ped.maxhealth = 4500
        ped.armor = 4500
        ped.health = 4500
        Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", Ped, 5.0F)
        Native.Function.Call("Set_Char_Climb_Anim_Rate", Ped, 4.0F)
        Ped.StartKillingSpree(alsoAttackPlayer:=True)
        ped.relationshipgroup = relationshipgroup.dealer
        ped.Weapons.MP5.Ammo = 99999
        ped.Weapons.Knife.Ammo = 99999
        Dim objct As gta.object = world.createobject("cj_barrier_7", ped.position)
        wait(20)
        objct.attachtoped(ped, 1204, New vector3(0.25F, 0.3F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
        objct.visible = False
        wait(10)
        objct = world.createobject("cj_barrier_7", ped.position)
        objct.visible = False
        wait(20)
        objct.attachtoped(ped, 1204, New vector3(0.0F, -0.3F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
        wait(10)
        objct = world.createobject("cj_barrier_7", ped.position)
        objct.visible = False
        wait(20)
        objct.attachtoped(ped, 1204, New vector3(0.05F, 0.0F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
    End Sub
    
    Private Sub Hydra2(ByVal ped As ped)
        Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "HE MULTIPLIED AGAIN!", 4000, 1)
        ped = world.createped("M_Y_Prison", player.character.position.around(20.0F).toground)
        ped.becomemissioncharacter()
        ped.CurrentRoom = Player.Character.CurrentRoom
        ped.SetPathfinding(True, True, True)
        ped.AlwaysDiesOnLowHealth = True
        ped.enemy = True
        ped.Accuracy = 100
        ped.maxhealth = 2250
        ped.armor = 2250
        ped.health = 2250
        Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", Ped, 5.0F)
        Native.Function.Call("Set_Char_Climb_Anim_Rate", Ped, 4.0F)
        Ped.StartKillingSpree(alsoAttackPlayer:=True)
        ped.Weapons.MP5.Ammo = 99999
        ped.Weapons.Knife.Ammo = 99999
        Dim objct As gta.object = world.createobject("cj_barrier_7", ped.position)
        wait(20)
        objct.attachtoped(ped, 1204, New vector3(0.25F, 0.3F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
        objct.visible = False
        wait(10)
        objct = world.createobject("cj_barrier_7", ped.position)
        objct.visible = False
        wait(20)
        objct.attachtoped(ped, 1204, New vector3(0.0F, -0.3F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
        wait(10)
        objct = world.createobject("cj_barrier_7", ped.position)
        objct.visible = False
        wait(20)
        objct.attachtoped(ped, 1204, New vector3(0.05F, 0.0F, 0.0F), New vector3(0.0F, 1.5F, 0.0F))
    End Sub
    Private Sub ScriptOn()
        SON = Not SON
        If SON Then
            player.character.MakeProofTo(False, True, False, False, False) 'Bullets,Fire,Explosions,FallingDamage,MeleeAttacks - tired of looking it up :)
        Else
            player.character.relationshipgroup = relationshipgroup.player
            player.character.MakeProofTo(False, False, False, False, False)
            Dim pedsz As ped() = World.GetAllPeds("M_Y_Prison")
            For Each ped As ped In pedsz
                If exists(ped) AndAlso ped.isrequiredformission = True Then
                    Dim WorldObjects As GTA.Object() = World.GetAllObjects("cj_barrier_7")
                    For Each obj As GTA.Object In WorldObjects
                        If Exists(obj) AndAlso obj.Position.DistanceTo(ped.Position) <= 4.0F Then
                            obj.delete()
                        End If
                    Next
                    
                End If
                If exists(ped) AndAlso ped.isalive = True Then
                    Ped.MakeProofTo(False, False, False, False, False)
                    ped.delete()
                End If
            Next
        End If
    End Sub
    Private Sub AddBlip()
        Dim peds As ped() = World.GetAllPeds("M_Y_Prison")
        For Each ped As ped In peds
            If exists(ped) AndAlso ped.isrequiredformission = True AndAlso ped.isalive = True Then
                If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.criminal = True Then
                    Dim blip As blip = blip.addblip(ped)
                    blip.color = blipcolor.white
                End If
                If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.dealer = True Then
                    Dim blip As blip = blip.addblip(ped)
                    blip.color = blipcolor.purple
                End If
                If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.dealer = False AndAlso ped.relationshipgroup = relationshipgroup.criminal = False Then
                    Dim blip As blip = blip.addblip(ped)
                    blip.color = blipcolor.grey
                End If
            End If
        Next
    End Sub
End Class
Public Class VillianForwardTelekinesis
    Inherits script
    Private SON As Boolean = False
    Private anims As New AnimationSet("gestures@mp_male")
    Private animflags As AnimationFlags = AnimationFlags.Unknown12 Or AnimationFlags.Unknown11 Or AnimationFlags.Unknown09
    Public Sub New()
        Me.interval = 4000
        settings.load()
        BindKey(Settings.GetValueKey("Toggle Script", "SETTINGS", Keys.F6), New KeyPressDelegate(AddressOf ScriptOn))
    End Sub
    Private Function RandomNumber(ByVal min As Integer, ByVal max As Integer) As Integer
        Dim random As New Random()
        Return random.Next(min, max)
    End Function
    Private Sub ThePush(ByVal p As ped)
        If p.heading >= 339 AndAlso p.heading <= 360 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next

        End If
        If p.heading >= 0 AndAlso p.heading <= 23 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next

        End If
        If p.heading >= 23 AndAlso p.heading <= 68 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next

        End If
        If p.heading >= 68 AndAlso p.heading <= 113 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, 0.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim WorldObjects As GTA.Object() = World.GetAllObjects()
        End If
        If p.heading >= 113 AndAlso p.heading <= 158 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next

        End If
        If p.heading >= 158 AndAlso p.heading <= 203 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim WorldObjects As GTA.Object() = World.GetAllObjects()

        End If
        If p.heading >= 203 AndAlso p.heading <= 248 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next

        End If
        If p.heading >= 248 AndAlso p.heading <= 293 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, 0.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim WorldObjects As GTA.Object() = World.GetAllObjects()

        End If
        If p.heading >= 293 AndAlso p.heading <= 340 Then
            Dim peds As Ped() = World.GetallPeds()
            For Each ped As Ped In peds
                If Exists(ped) AndAlso ped.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                        Ped.isRagdoll = True
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
            Dim vehicles As vehicle() = world.getallvehicles()
            For Each vehicle As Vehicle In vehicles
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            Next
        End If
    End Sub
    Private Sub VillianPush_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If SON Then
            Dim random As New Random()
            Dim a As Integer = RandomNumber(1, 4)
            If a = 2 Then
                Dim pedz As ped() = World.GetAllPeds("M_Y_Prison")
                For Each ped As ped In pedz
                    If exists(ped) AndAlso Player.Character.Position.DistanceTo(ped.Position) >= 2.0F AndAlso ped.isrequiredformission = True AndAlso ped.isalive = True Then
                        Ped.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                        Native.Function.Call("FREEZE_CHAR_POSITION", ped, True)
                        wait(100)
                        ThePush(ped)
                        wait(200)
                        Native.Function.Call("FREEZE_CHAR_POSITION", ped, False)
                    End If
                Next
            End If
        End If
    End Sub
    Private Sub ScriptOn()
        SON = Not SON
        If SON Then
        Else
        End If
    End Sub
End Class
Public Class VillianTelekineticRipple
    Inherits script
    Private SON As Boolean = False
    Private anims As New AnimationSet("amb@shock")
    Private animflags As AnimationFlags = AnimationFlags.Unknown12 Or AnimationFlags.Unknown11 Or AnimationFlags.Unknown09
    Public Sub New()
        Me.interval = 6500
        settings.load()
        BindKey(Settings.GetValueKey("Toggle Script", "SETTINGS", Keys.F6), New KeyPressDelegate(AddressOf ScriptOn))
    End Sub
    Private Function RandomNumber(ByVal min As Integer, ByVal max As Integer) As Integer
        Dim random As New Random()
        Return random.Next(min, max)
    End Function
    Private Sub ShockWave_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If SON Then
            Dim random As New Random()
            Dim a As Integer = RandomNumber(1, 5)
            If a = 3 Then
                Dim pedz As ped() = World.GetAllPeds("M_Y_Prison")
                For Each ped As ped In pedz
                    If exists(ped) AndAlso Player.Character.Position.DistanceTo(ped.Position) >= 2.0F AndAlso ped.isrequiredformission = True AndAlso ped.isalive = True Then
                        ped.visible = True
                        Ped.Task.PlayAnimation(anims, "shock_c", 7.0F, animflags)
                        Native.Function.Call("FREEZE_CHAR_POSITION", ped, True)
                        wait(100)
                        TheShockWave(ped)
                        wait(200)
                        Native.Function.Call("FREEZE_CHAR_POSITION", ped, False)
                        ped.visible = False
                    End If
                Next
            End If
        End If
    End Sub
    Private Sub PutOutVillianOnFire_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If SON Then
            Dim pedz As ped() = World.GetAllPeds("M_Y_Prison")
            For Each ped As ped In pedz
                If exists(ped) AndAlso Player.Character.Position.DistanceTo(ped.Position) >= 2.0F AndAlso ped.isonfire = True AndAlso ped.isrequiredformission = True AndAlso ped.isalive = True Then
                    ped.visible = True
                    Ped.isonfire = False
                End If
            Next
        End If
    End Sub
    Private Sub TheShockWave(ByVal P As ped)
        If Son Then
            If exists(P) Then
                Dim peds As ped() = world.getallpeds()
                For Each ped As ped In peds
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If P.Position.DistanceTo(Ped.Position) <= 15.0F AndAlso P.Position.DistanceTo(Ped.Position) >= 1.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                            Ped.ForceRagdoll(3000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 8.0F, 0.0F, 0.0F, 0.0F, True, True, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehicles
                    If exists(vehicle) Then
                        If P.Position.DistanceTo(vehicle.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 8.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjects As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjects
                    If exists(obj) Then
                        If P.Position.DistanceTo(obj.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 8.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                wait(175)
                Dim pedz As ped() = world.getallpeds()
                For Each ped As ped In pedz
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If P.Position.DistanceTo(ped.Position) >= 14.0F AndAlso P.Position.DistanceTo(ped.Position) < 30.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, True, True, True, True)
                        End If
                    End If
                Next
                Dim vehiclez As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehiclez
                    If exists(vehicle) Then
                        If P.Position.DistanceTo(vehicle.Position) >= 14.0F AndAlso P.Position.DistanceTo(vehicle.Position) < 30.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjectsa As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsa
                    If exists(obj) Then
                        If P.Position.DistanceTo(obj.Position) >= 14.0F AndAlso P.Position.DistanceTo(obj.Position) < 30.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                wait(175)
                Dim pedr As ped() = world.getallpeds()
                For Each ped As ped In pedr
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If P.Position.DistanceTo(ped.Position) >= 29.0F AndAlso P.Position.DistanceTo(ped.Position) < 45.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, True, True, True, True)
                        End If
                    End If
                Next
                Dim vehicler As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehicler
                    If exists(vehicle) Then
                        If P.Position.DistanceTo(vehicle.Position) >= 29.0F AndAlso P.Position.DistanceTo(vehicle.Position) < 45.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjectsb As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsb
                    If exists(obj) Then
                        If P.Position.DistanceTo(obj.Position) >= 29.0F AndAlso P.Position.DistanceTo(obj.Position) < 45.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                wait(175)
                Dim pedt As ped() = world.getallpeds()
                For Each ped As ped In pedt
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If P.Position.DistanceTo(ped.Position) >= 44.0F AndAlso P.Position.DistanceTo(ped.Position) < 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 6.0F, 0.0F, 0.0F, 0.0F, True, True, True, True)
                        End If
                    End If
                Next
                Dim vehiclet As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehiclet
                    If exists(vehicle) Then
                        If P.Position.DistanceTo(vehicle.Position) >= 44.0F AndAlso P.Position.DistanceTo(vehicle.Position) < 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 6.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjectsc As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsc
                    If exists(obj) Then
                        If P.Position.DistanceTo(obj.Position) >= 44.0F AndAlso P.Position.DistanceTo(obj.Position) < 60.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 6.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                wait(175)
                Dim pedts As ped() = world.getallpeds()
                For Each ped As ped In pedts
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If P.Position.DistanceTo(ped.Position) >= 59.0F AndAlso P.Position.DistanceTo(ped.Position) < 75.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 4.5F, 0.0F, 0.0F, 0.0F, True, True, True, True)
                        End If
                    End If
                Next
                Dim vehiclets As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehiclets
                    If exists(vehicle) Then
                        If P.Position.DistanceTo(vehicle.Position) >= 59.0F AndAlso P.Position.DistanceTo(vehicle.Position) < 75.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 4.5F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjectsd As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsd
                    If exists(obj) Then
                        If P.Position.DistanceTo(obj.Position) >= 59.0F AndAlso P.Position.DistanceTo(obj.Position) < 75.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 4.5F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                wait(175)
                Dim pedvs As ped() = world.getallpeds()
                For Each ped As ped In pedvs
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If P.Position.DistanceTo(ped.Position) >= 74.0F AndAlso P.Position.DistanceTo(ped.Position) < 90.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 2.0F, 0.0F, 0.0F, 0.0F, True, True, True, True)

                        End If
                    End If
                Next
                Dim vehiclevs As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehiclevs
                    If exists(vehicle) Then
                        If P.Position.DistanceTo(vehicle.Position) >= 74.0F AndAlso P.Position.DistanceTo(vehicle.Position) < 90.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 2.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjectse As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectse
                    If exists(obj) Then
                        If P.Position.DistanceTo(obj.Position) >= 74.0F AndAlso P.Position.DistanceTo(obj.Position) < 90.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 2.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim pedsvn As Ped() = World.GetallPeds()
                For Each ped As Ped In pedsvn
                    If Exists(ped) Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F AndAlso ped.model = "M_Y_PRISON" = False Then
                            Ped.isOnFire = True
                        End If
                    End If
                Next
                Dim vehiclesvn As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehiclesvn
                    If exists(vehicle) Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            vehicle.explode()
                        End If
                    End If
                Next
                Dim WorldObjectsvn As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsvn
                    If Exists(obj) Then
                        If Player.Character.Position.DistanceTo(obj.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(obj.Position) <= 60.0F Then
                            obj.isOnFire = True
                        End If
                    End If
                Next
            End If
        End If
    End Sub
    Private Sub ScriptOn()
        SON = Not SON
        If SON Then
        Else
        End If
    End Sub
End Class
Public Class SuperPowers
    Inherits script
    Private SON As Boolean = False
    Private flash As Boolean = False
    Private flash2 As Boolean = False
    Private levi As Boolean = False
    Private pdali As Boolean = False
    Private timer As New GTA.Timer
    Private anims As New AnimationSet("gestures@mp_male")
    Private anims2 As New AnimationSet("amb@shock")
    Private animflags As AnimationFlags = AnimationFlags.Unknown12 Or AnimationFlags.Unknown11 Or AnimationFlags.Unknown09
    Public Sub New()
        Me.interval = 190
        settings.load()
        BindKey(Settings.GetValueKey("Toggle Script", "SETTINGS", Keys.F6), New KeyPressDelegate(AddressOf ScriptOn))
        BindKey(Settings.GetValueKey("Bullet Time", "SETTINGS", Keys.H), New KeyPressDelegate(AddressOf TheTime))
        BindKey(Settings.GetValueKey("Run Fast", "SETTINGS", Keys.Y), New KeyPressDelegate(AddressOf TheFlash2))
        BindKey(Settings.GetValueKey("Telekinetic Ripple", "SETTINGS", Keys.L), New KeyPressDelegate(AddressOf TheStomp))
        BindKey(Settings.GetValueKey("Mass Push", "SETTINGS", Keys.K), New KeyPressDelegate(AddressOf ThePush))
        BindKey(Settings.GetValueKey("Single Ped Push", "SETTINGS", Keys.J), New KeyPressDelegate(AddressOf TheSinglePedPush))
        BindKey(Settings.GetValueKey("Single Vehicle Push", "SETTINGS", Keys.N), New KeyPressDelegate(AddressOf TheSingleVehiclePush))
        BindKey(Settings.GetValueKey("Alter Gravity", "SETTINGS", Keys.M), New KeyPressDelegate(AddressOf AlterGravity))
        BindKey(Settings.GetValueKey("Police Alliance", "SETTINGS", Keys.T), New KeyPressDelegate(AddressOf PoliceAlliance))
    End Sub
    Private Sub PoliceAlliance()
        If SON Then
            pdali = Not pdali
            If pdali Then
                player.character.relationshipgroup = relationshipgroup.cop
                player.wantedlevel = 0
                Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Police Alliance", 4000, 1)
            Else
                player.character.relationshipgroup = relationshipgroup.player
                Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "No Alliance", 4000, 1)
                player.wantedlevel = 0
            End If
        End If
    End Sub
    Private Sub TheTime()
        If SON Then
            flash = Not flash
            If flash Then
                Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Bullet Time Active", 4000, 1)
                game.timescale = 0.3
            Else
                Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Bullet Time Off", 4000, 1)
                game.timescale = 1.0
            End If
        End If
    End Sub
    Private Sub TheFlash2()
        If SON Then
            flash2 = Not flash2
            If flash2 Then
                Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "High Movement Speed On", 4000, 1)
                Dim ped As ped = player.character
                Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", Ped, 2.7F)
                Native.Function.Call("Set_Char_Climb_Anim_Rate", Ped, 2.7F)
            Else
                Dim p As ped = player.character
                If exists(p) Then
                    Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "High Movement Speed Off", 4000, 1)
                    Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", P, 1.0F)
                    Native.Function.Call("Set_Char_Climb_Anim_Rate", P, 1.0F)
                End If
            End If
        End If
    End Sub
    Private Sub HealthandArmorRegeneration_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If SON Then
            If Not flash Then
                If Not flash2 Then
                    If Not levi Then
                        If player.character.health < 100 Or player.character.armor < 100 Then
                            Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Regeneration Active", 4000, 1)
                            Player.Character.Health += 8.0
                            Player.Character.Armor += 8.0
                        End If
                    End If
                End If
            End If
        End If
    End Sub
    Private Sub ScriptOn()
        SON = Not SON
        If SON Then
            Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Powers Acquired", 4000, 1)
            player.character.cancelambientspeech()
            Player.character.MakeProofTo(False, False, False, True, False) 'Bullets,Fire,Explosions,FallingDamage,MeleeAttacks - tired of looking it up :)
        Else
            Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", "Powers Gone", 4000, 1)
            Player.Character.Health = 100
            Player.Character.Armor = 100
            Native.Function.Call("Set_Char_Move_Anim_Speed_Multiplier", Player.character, 1.0F)
            Native.Function.Call("Set_Char_Climb_Anim_Rate", Player.character, 1.0F)
            Player.character.MakeProofTo(False, False, False, False, False)
            game.timescale = 1.0
            player.wantedlevel = 0
            World.GravityEnabled = True
        End If
    End Sub
    Private Sub AlteringGravity_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
        If SON Then
            If levi Then
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehicles
                    If exists(vehicle) AndAlso Vehicle.isOnAllWheels = False Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 2.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                    End If
                    If exists(vehicle) AndAlso Vehicle.isOnAllWheels = True Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 3.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                    End If
                Next
                Dim peds1 As ped() = world.getallpeds()
                For Each ped As ped In peds1
                    If exists(ped) AndAlso ped = player.character = False AndAlso ped.isinair = True Then
                        Ped.ForceRagdoll(2000, False)
                    End If
                    If exists(ped) AndAlso ped = player.character = False AndAlso ped.isinair = False Then
                        Ped.ForceRagdoll(2000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 0.3F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                    If exists(ped) AndAlso ped = player.character = False AndAlso ped.isinair = True AndAlso ped.isrequiredformission = True AndAlso ped.model = "M_Y_Prison" = True Then
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, -2.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                Next
                If player.character.isinair = True Then
                    Native.Function.Call("APPLY_FORCE_TO_PED", player.character, True, 0.0F, 0.0F, -1.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                End If
            End If
        End If
    End Sub
    Private Sub AlterGravity()
        If SON Then
            levi = Not levi
            If levi Then
                TheStomp()
                World.GravityEnabled = False
            Else

                Dim peds1 As ped() = world.getallpeds()
                For Each ped As ped In peds1
                    If exists(ped) Then
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, -0.5F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                Next
                Dim vehicles1 As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehicles1
                    If exists(vehicle) Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, -0.5F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                    End If

                Next
                Dim WorldObjects1 As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjects1
                    If exists(obj) Then
                        Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, -0.5F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                    End If
                Next
                World.GravityEnabled = True
            End If
        End If
    End Sub
    Private Sub TheStomp()
        If SON Then
            If exists(player.character) AndAlso player.character.isinvehicle = False Then
                player.character.makeproofto(False, False, True, True, False)
                Player.Character.Task.PlayAnimation(anims2, "shock_c", 7.0F, animflags)
                Dim peds As ped() = world.getallpeds()
                For Each ped As ped In peds
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If Player.Character.Position.DistanceTo(Ped.Position) <= 15.0F AndAlso Player.Character.Position.DistanceTo(Ped.Position) >= 1.0F Then
                            Ped.ForceRagdoll(2000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 8.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)

                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehicles
                    If exists(vehicle) Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 8.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjects As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjects
                    If exists(obj) Then
                        If Player.Character.Position.DistanceTo(obj.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 8.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next

                wait(175)
                Dim pedz As ped() = world.getallpeds()
                For Each ped As ped In pedz
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 14.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) < 30.0F Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)

                        End If
                    End If
                Next
                Dim vehiclez As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehiclez
                    If exists(vehicle) Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 14.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) < 30.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjectsa As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsa
                    If exists(obj) Then
                        If Player.Character.Position.DistanceTo(obj.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next


                wait(175)
                Dim pedr As ped() = world.getallpeds()
                For Each ped As ped In pedr
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 29.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) < 45.0F Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)

                        End If
                    End If
                Next
                Dim vehicler As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehicler
                    If exists(vehicle) Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 29.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) < 45.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next

                Dim WorldObjectsb As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsb
                    If exists(obj) Then
                        If Player.Character.Position.DistanceTo(obj.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 7.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next

                wait(175)
                Dim pedt As ped() = world.getallpeds()
                For Each ped As ped In pedt
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 44.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) < 60.0F Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 6.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)

                        End If
                    End If
                Next
                Dim vehiclet As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehiclet
                    If exists(vehicle) Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 44.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) < 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 6.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next

                Dim WorldObjectsc As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsc
                    If exists(obj) Then
                        If Player.Character.Position.DistanceTo(obj.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 6.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next

                wait(175)
                Dim pedts As ped() = world.getallpeds()
                For Each ped As ped In pedts
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 59.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) < 75.0F Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 4.5F, 0.0F, 0.0F, 0.0F, True, False, True, True)

                        End If
                    End If
                Next
                Dim vehiclets As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehiclets
                    If exists(vehicle) Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 59.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) < 75.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 4.5F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next

                Dim WorldObjectsd As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectsd
                    If exists(obj) Then
                        If Player.Character.Position.DistanceTo(obj.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 4.5F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next

                wait(175)
                Dim pedvs As ped() = world.getallpeds()
                For Each ped As ped In pedvs
                    If exists(ped) AndAlso ped.relationshipgroup = relationshipgroup.player = False Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 74.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) < 90.0F Then
                            Ped.ForceRagdoll(6000, False)
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 0.0F, 2.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)

                        End If
                    End If
                Next
                Dim vehiclevs As vehicle() = world.getallvehicles()
                For Each vehicle As vehicle In vehiclevs
                    If exists(vehicle) Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 74.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) < 90.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 0.0F, 2.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                Dim WorldObjectse As GTA.Object() = World.GetAllObjects()
                For Each obj As GTA.Object In WorldObjectse
                    If exists(obj) Then
                        If Player.Character.Position.DistanceTo(obj.Position) <= 15.0F Then
                            Native.Function.Call("Apply_Force_To_Object", obj, True, 0.0F, 0.0F, 2.0F, 0.0F, 0.0F, 0.0F, False, False, False, True)
                        End If
                    End If
                Next
                player.character.makeproofto(False, False, False, True, False)
            End If
        End If
    End Sub

    Private Sub ThePush()
        If SON Then

            Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)

            If player.character.heading >= 339 AndAlso player.character.heading <= 360 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)

                        End If
                    End If
                Next
            End If

            If player.character.heading >= 0 AndAlso player.character.heading <= 23 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
            End If

            If player.character.heading >= 23 AndAlso player.character.heading <= 68 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
            End If

            If player.character.heading >= 68 AndAlso player.character.heading <= 113 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, 0.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
            End If

            If player.character.heading >= 113 AndAlso player.character.heading <= 158 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
            End If

            If player.character.heading >= 158 AndAlso player.character.heading <= 203 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
            End If

            If player.character.heading >= 203 AndAlso player.character.heading <= 248 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
            End If

            If player.character.heading >= 248 AndAlso player.character.heading <= 293 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, 0.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
            End If

            If player.character.heading >= 293 AndAlso player.character.heading <= 340 Then
                Dim peds As Ped() = World.GetallPeds()
                For Each ped As Ped In peds
                    If Exists(ped) AndAlso ped.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(ped.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                            Ped.isRagdoll = True
                            Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
                Dim vehicles As vehicle() = world.getallvehicles()
                For Each vehicle As Vehicle In vehicles
                    If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                        If Player.Character.Position.DistanceTo(vehicle.Position) >= 3.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                            Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        End If
                    End If
                Next
            End If
        End If
    End Sub
    Private Sub TheSinglePedPush()
        If SON Then
            If player.character.heading >= 339 AndAlso player.character.heading <= 360 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If

            If player.character.heading >= 0 AndAlso player.character.heading <= 23 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If

            If player.character.heading >= 23 AndAlso player.character.heading <= 68 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If

            If player.character.heading >= 68 AndAlso player.character.heading <= 113 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, 0.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If

            If player.character.heading >= 113 AndAlso player.character.heading <= 158 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, -30.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If

            If player.character.heading >= 158 AndAlso player.character.heading <= 203 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 0.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If

            If player.character.heading >= 203 AndAlso player.character.heading <= 248 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, -30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If

            If player.character.heading >= 248 AndAlso player.character.heading <= 293 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, 0.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If

            If player.character.heading >= 293 AndAlso player.character.heading <= 340 Then
                Dim peds As Ped() = World.GetPeds(Player.Character.GetOffsetPosition(New Vector3(0.0F, 3.0F, 0.0F)), 4.0F, 2)
                For Each ped As ped In peds
                    If Exists(ped) AndAlso ped = player.character = False AndAlso ped.isonscreen = True AndAlso ped.isinvehicle = False AndAlso Player.Character.Position.DistanceTo(ped.Position) <= 60.0F Then
                        Ped.ForceRagdoll(3000, False)
                        Native.Function.Call("APPLY_FORCE_TO_PED", ped, True, 30.0F, 30.0, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                        Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)
                    End If
                Next
            End If
        End If
    End Sub
    Private Sub TheSingleVehiclePush()
        If SON Then

            Player.Character.Task.PlayAnimation(anims, "wave", 7.0F, animflags)

            If player.character.heading >= 339 AndAlso player.character.heading <= 360 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If

            If player.character.heading >= 0 AndAlso player.character.heading <= 23 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If

            If player.character.heading >= 23 AndAlso player.character.heading <= 68 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If

            If player.character.heading >= 68 AndAlso player.character.heading <= 113 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If

            If player.character.heading >= 113 AndAlso player.character.heading <= 158 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, -30.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If

            If player.character.heading >= 158 AndAlso player.character.heading <= 203 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 0.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If

            If player.character.heading >= 203 AndAlso player.character.heading <= 248 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, -30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If

            If player.character.heading >= 248 AndAlso player.character.heading <= 293 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If

            If player.character.heading >= 293 AndAlso player.character.heading <= 340 Then
                Dim vehicle As vehicle = world.getclosestvehicle(player.character.position, 15.0)
                If exists(vehicle) AndAlso vehicle.isonscreen = True Then
                    If Player.Character.Position.DistanceTo(vehicle.Position) >= 2.0F AndAlso Player.Character.Position.DistanceTo(vehicle.Position) <= 60.0F Then
                        Native.Function.Call("Apply_Force_To_Car", vehicle, True, 30.0F, 30.0F, 0.0F, 0.0F, 0.0F, 0.0F, True, False, True, True)
                    End If
                End If
            End If
        End If
    End Sub
End Class
